/*	This program ensures the communication with Xref-Speller.
*/

package sk.xref.kawa;			

import java.io.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import com.tektools.kawa.plugin.*;

// static variables must be put in a class which is not reloaded.

public class XrefCall {
	
	// the following flag specifies whether to pass Xref-Speller
	// answer via pipe or temporary file. Surprisingly, temporary
	// files are faster.
	static final private boolean ofileFlag=true;


	static private String lastMessage = "#XrEf-iO-End#";

	static public String kawaProjectPath() {
		String xfile = "C:\\defaultxrefcommunicationfile";
		try {
			KawaProject proj = KawaApp.getCurrentProject();
			xfile = proj.getPath();
//		    KawaApp.build.println("xfile == " + xfile);
			xfile = xfile.substring(0,xfile.length()-4);
		} catch (Exception e) {
		    KawaApp.out.println("[error] while getting project name. Maybe no opened project?");
			System.exit(1);
		}
		return(xfile);
	}

	public static String callProcess(String args) {
		String		putargs = null;
		String 		res = "";
		String		xrefTmpFile2 = null;
		int 			i,c,reslen,lmlen;
		boolean 	loop;
		putargs = args;
 		if (ofileFlag) {
 			xrefTmpFile2 = kawaProjectPath() + ".xro" ;
			putargs += " -o \"" + xrefTmpFile2 + "\" " ;
 		}
 		putargs += " -last_message=" + lastMessage + " end-of-options\n";
		//KawaApp.build.println(putargs);
		if (Statics.x == null) Statics.x = new XrefProcess();
		if (Statics.x.pp == null) Statics.x = new XrefProcess();
 		try {
	 		PrintStream ss = new PrintStream(Statics.x.oo);
 			ss.println(putargs);
 			Statics.x.oo.flush();
		} catch (IOException e) {
			Statics.x.killThis();
			Statics.x = new XrefProcess();
			try {
	 			PrintStream ss = new PrintStream(Statics.x.oo);
  			ss.println(putargs);
  			Statics.x.oo.flush();
			} catch (Exception e2) {
				return("*[xref error] can't start the process or pass options");
			}
   	}
   	res = ""; reslen = 0; lmlen = lastMessage.length();
   	loop = true; c = 0;
	//KawaApp.build.println("here I am waiting output");
 		try {
	  	while (c != -1 && loop) {
  	 		c = Statics.x.ii.read();	
   			res = res + (char)c;
			//KawaApp.build.print(""+(char)c);
		 		reslen ++;
  	 		if (reslen >= lmlen && ((char)c) == '#') {
   				if (lastMessage.equals(res.substring(reslen-lmlen))) {
   					loop = false;
   				}
	   		}
  	 	}
  	} catch (Exception e) {
			return("*[xref error] can't get process answer");
		}
		
		//KawaApp.build.println("output finished");
 		if (loop == false && reslen>lmlen) {
   			res = res.substring(0, reslen-lmlen);	
   	}
   	try {
    	if (ofileFlag) {
  		  	File ifl = new File(xrefTmpFile2);
    		FileReader iff = new FileReader(ifl);
	    	BufferedReader	idf = new BufferedReader(iff);
    		res = ""; loop = true;
    		while (loop) {
    			res = res + idf.readLine();
	    		if (idf.ready()) res = res + "\n";
    			else loop = false;
    		}
	    	iff.close();
    		ifl.delete();
    	}
 	} catch (Exception e) {
		return("*[xref error] can't read process answer");
	}
   	return(res);
	}
			

	private static void writeList(String data) {
		KawaApp.build.clearWindow();
		KawaApp.build.showWindow(true);
		KawaApp.build.println(data);
	}
	

	public static void moveTo(String data) {
		try {
			int 					p1= -1;
			do {
				p1 = data.indexOf('#',p1+1);
			} while (p1>0 && ! data.substring(p1,p1+5).equals("#*+*#"));
			if (p1 == -1) {
				KawaApp.build.println("[xref error] no file/pos marker in '" + data + "'");					
				return;
			}
			StringBufferInputStream sb = new StringBufferInputStream(data.substring(p1+5));
			StreamTokenizer st = new StreamTokenizer(sb);
			String				file = data.substring(0,p1);
			st.nextToken();
			long					line = (long) st.nval;
			st.nextToken();
			int						coll = (int) st.nval;
			KawaFile 		ff = new KawaFile(file);
			KawaEditor 		ed = ff.getEditor(true);
//			KawaEditor ed=new KawaEditor(file);
			ed.gotoLine(line,false);
			int linebase = (int) ed.getLineIndex(line);
			int pos = linebase + coll;
			ed.setSelect(pos, pos);
		} catch (Exception e) {
			KawaApp.build.println("[xref error] problem while processing the reference '" + data + "'");	
		}
	}
	


	public static void makeAnswer(String xx, KawaEditor ed) {
		int xxlen = xx.length();
		if (xxlen <= 1) return;
		String pilot = xx.substring(0,1);
		String data = xx.substring(1,xxlen);
		if (pilot.equals(",")) {
			if (ed==null) KawaApp.build.println("[xref] null editor, internal error");
			else ed.paste(data);
		} else if (pilot.equals(".")) {
			if (ed==null) KawaApp.build.println("[xref] null editor, internal error");
			else ed.paste(data);
		} else if (pilot.equals(":")) {
			writeList(data);
//			popupMenuTest(data);
		} else if (pilot.equals(";")) {
			writeList(data);
		} else if (pilot.equals("#")) {		// goto reference
			moveTo(data);
		} else if (pilot.equals("@")) {		// pop reference ?
			moveTo(data);
		} else if (pilot.equals("*")) {		// message
			writeList(data);
		} else if (pilot.equals("-")) {		// no completion
		} else if (pilot.equals("_")) {		// no reference
		} else if (pilot.equals("=")) {		// empty stack
		} else {
			writeList(data);			
		}
	}
	
	
	public static void action(String[] args,
															String opts,
															boolean passFileFlag) {
		int 					i,argsbeg=0;
		String 				inFile = null;
		File 					ofl = null;
		KawaEditor 		ed = null;
		if (passFileFlag) {
			inFile = args[0];
			argsbeg = 1;
		}
		int argc = args.length;
		String xfile = XrefCall.kawaProjectPath() + ".xrf";
		String options = "";
		for (i=argsbeg; i<argc; i++) options += args[i] + " ";
		options += opts + " -refs \"" + xfile + "\" "; 
		KawaProject proj = KawaApp.getCurrentProject();
		options += " -p \"" + proj.getName() + "\" ";
		//options += "-classpath "+ proj.getClasspath(true) + " ";
		try {
			if (passFileFlag) {
				String xrefTmpFile = kawaProjectPath() + ".xri";
				KawaFile ff = new KawaFile(inFile);
				ed = ff.getEditor(true);
				long	bpos = ed.getSelectStart();
				long 	cpos = ed.getSelectEnd();
				options += "-olcursor=" + cpos + " -olnodialog" +
										" -kawa -file \"" + inFile + "\" " +
										"\"" + xrefTmpFile + "\"" ;
				ofl = new File(xrefTmpFile);
				FileOutputStream off = new FileOutputStream(ofl);
				DataOutputStream	odf = new DataOutputStream(off);
				ed.setSelect(0, -1);
				odf.writeBytes(ed.getSelectText()); 
				ed.setSelect((int)bpos, (int)cpos);
//				odf.writeBytes(ed.getEditorText());
				off.close();
			}
			//KawaApp.build.println(options);
			String cc = callProcess(	options	);
			if (ofl != null) ofl.delete();
			//KawaApp.build.println(cc);
			makeAnswer(cc, ed);					
		} catch (Exception e) {
			KawaApp.build.println("[xref error] problem while accessing the current file");
		}
	}

	public static void execSingleProcess(String calls) {
		boolean loop;
		int c;
		try {
 			KawaApp.build.clearWindow();
			KawaApp.build.showWindow(true);
			Runtime rt = Runtime.getRuntime();
			KawaApp.build.println(calls);
			Process pp = rt.exec(calls);
			InputStream ii = pp.getInputStream();
		   	loop = true; c = 0;
 	 		c = ii.read();	
		 	while (c != -1 && loop) {
				KawaApp.build.print(""+(char)c);
  	 		c = ii.read();	
  	 	}
			ii.close();
 		} catch (Exception e) {
			KawaApp.build.println("\n[xref error] something goes wrong while executing process");
		}
	}

}
 
