
/*
		This program invokes the Xref-Speller in order to create the
		cross-reference file of the current project

		
		The 'xref.exe' file must be located in a directory listed in
		your PATH variable. Note that Xref-Speller is unable to read 
		compressed '.zip' and '.jar' files. In order to use it 
		efficiently, please, unzip those archives and then re-zip
		them with 'none' compression. Note that there is no need 
		to re-zip the standard class libraries such as 'classes.zip'
		or 'rt.jar' as they are distributed with none compresion.
*/

import java.io.*;	
import java.util.*;
import com.tektools.kawa.plugin.*;
import sk.xref.kawa.*;			


/** create Xref-Speller tag file */

class CreateXrefTagFile {
	
	public static void main(String[] args) {
		boolean 	loop;
		int 			c;
		int				argc = args.length;
		String calls = "xref -stderr -last_message=Done.";
		String xfile = XrefCall.kawaProjectPath() + ".xrf";
		calls += " -refs \"" + xfile + "\"";
		KawaProject proj = KawaApp.getCurrentProject();
		calls += " -p \"" + proj.getName() + "\"";
		Enumeration fileEnum = proj.enumerateAllFiles();
		while(fileEnum.hasMoreElements())	{
			KawaFile file = (KawaFile)fileEnum.nextElement();
			if(file != null) calls += " \"" + file.getPath() + "\"";
		}
		for (int i=0; i<argc; i++) calls = calls + " " + args[i];
		XrefCall.execSingleProcess(calls);
	}
}